/*
 *     terraVox: an experimental voxel landscape engine
 *
 *     Copyright (C) 1999/2000 Alex J. Champandard
 *
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *     The tutorial that accompanies this source code can be found at
 *         http://www.flipcode.com
 *
 *     You can also visit the terraVox web site at
 *         http://atlas.cs.york.ac.uk/~ajc116/terraVox
 *
 *     And if you wish to contact me for any reason, I can be reached at
 *         alexjc@altavista.com
 *
 */

#include <sys/nearptr.h>
#include <dpmi.h>
#include <dos.h>
#include <malloc.h>
#include <string.h>
#include "vga.h"

VGA::VGA()
{
// set mode 0x13
   union REGS regs;
   regs.x.ax = 0x13;
   int86( 0x10, &regs, &regs );
// setup palette
   for (int i=0; i<256; i++) {
        outp(0x3c8, i );
        outp(0x3c9, i>>2 );
        outp(0x3c9, i>>2 );
        outp(0x3c9, i>>2 );
    }
// setup tripple buffering
  page_draw    = (unsigned char *)malloc( 64000 );
// clear pages
  memset( page_draw,    0, 64000 );
// disable memory checking
  __djgpp_nearptr_enable();
// get pointer to video memory
  video_buffer = (unsigned char *)( 0xA0000 + __djgpp_conventional_base );
// clear video memory
  memset( video_buffer, 0, 64000 );
};

VGA::~VGA()
{
// set mode 0x03
   union REGS regs;
   regs.x.ax = 0x03;
   int86( 0x10, &regs, &regs );
// enable memory checking
   __djgpp_nearptr_disable();
// free memory
   free( page_draw );
};

void VGA::Update()
{
 // wait for retrace, NOT! :)
//   while (inportb(0x3da) & 0x08);
//   while (!(inportb(0x3da) & 0x08));
 // dump page_wait to the screen
   memcpy( video_buffer, page_draw, 64000 );
};
